#ifndef __LINKED_LIST_H__
#define __LINKED_LIST_H__

/**
 * Generic linked list datatype
 */
typedef struct LINKED_LIST_s {
	/** pointer to node data */
	void* data;
	/** pointer to next node of the list, <code>NULL</code> if it is the last */
	struct LINKED_LIST_s* next;
} /// 
LINKED_LIST_t;

/**
 * Create a new node
 * 
 * @param data pointer to node's data
 * @param next pointer to next element in the list
 * @return the pointer to newly created node
 */
LINKED_LIST_t* LINKED_LIST_new(void* data, LINKED_LIST_t* next);

/**
 * Delete a linked list.
 * 
 * @remarks It doesn't delete node data
 */
void LINKED_LIST_delete(LINKED_LIST_t* node);

#endif
